version: '2.4'
services:
  # Description: Jaeger all-in-one instance
  # (https://www.jaegertracing.io/docs/1.17/getting-started/#all-in-one) for distributed tracing.
  #
  # Disk: none
  # Ports exposed to other Sourcegraph services: 5778/TCP 6831/UDP 6832/UDP 14250/TCP
  # Ports exposed to the public internet: none
  # Ports exposed to site admins only: 16686/HTTP
  #
  jaeger:
    container_name: jaeger
    image: 'index.docker.io/sourcegraph/jaeger-all-in-one:4.0.1@sha256:0faceb8a774c9068ffe4d592034e2a6a4581b4438b7c8e9b0d45fc4e576fb6bb'
    cpus: 0.5
    mem_limit: '512m'
    ports:
      # Query port
      - '0.0.0.0:16686:16686'
      # Collector port
      - '0.0.0.0:14250:14250'
      # Agent ports
      - '0.0.0.0:5778:5778'
      - '0.0.0.0:6831:6831'
      - '0.0.0.0:6832:6832'
    networks:
      - sourcegraph
    restart: always
    command: ['--memory.max-traces=20000']
    environment:
      - 'SAMPLING_STRATEGIES_FILE=/etc/jaeger/sampling_strategies.json'

  # Configure collector to send traces to Jaeger
  otel-collector:
    environment:
      - JAEGER_HOST=jaeger
    command: ['--config', '/etc/otel-collector/configs/jaeger.yaml']

  # Let frontend proxy to Jaeger interface
  sourcegraph-frontend-0:
    environment:
      - 'JAEGER_SERVER_URL=http://jaeger:16686'

  sourcegraph-frontend-internal:
    environment:
      - 'JAEGER_SERVER_URL=http://jaeger:16686'
